from abc import ABC, abstractmethod
from enum import Enum


class InferenceMode(Enum):
    WHOLE_IMAGE = 0
    ALL_ROIS = 1
    SELECTED_ROIS = 2


class Runtime(Enum):
    ONNX_RUNTIME = 0
    TENSORRT = 1


class BaseModel(ABC):

    @abstractmethod
    def preprocess(self, item):
        pass

    @abstractmethod
    def predict(self, input_batch):
        pass

    @abstractmethod
    def postprocess(self, prediction_output, item):
        pass

    @abstractmethod
    def destroy(self):
        pass
